//<c>   Copyright 1998-1999 by Gerry J. Danen; all rights reserved.

//<t>   Create a batch file to rename all files and directories

#include"gd_tools.h"
#include"gd_extrn.h"


#define pgVERS_ "V1.03"
#define pgTITL_ "Create batch file to Rename Files & Directories"
#define pgCOPR_ "1998"


UCHAR   searchstr[FS_LEN] = "*.*",              // file spec to search for
        batFile[FS_LEN] = "RenAll$.bat" ;       // output batch file
FILE    *fBat ;


//      prototype
void    match_files(void);


void    program_usage( void )
{
    logon(1);
    fprintf( stderr, "\nUsage: %s batch_filename\n\n"
                     "Processing starts in the current directory, and works downward.\n\n",
            get_global_program_name() );
    exit( BAD_EXIT );
}


void    match_files( void )
/*
        This procedure searches for files that match the SEARCHSTR.  Once a
        match is found, its name and other information is written to the
        output file.  This procedure is recursive.
*/
{
    char        curdir[FS_LEN], temp[3] ;
    int         done, attrib ;
    struct find_t dta ;
    BOOL        isRoot ;

    _getcwd( curdir, sizeof(curdir) );
    fprintf( stderr, "%s\n", curdir );
    _strlwr( curdir );

    if ( (strlen(curdir) == 3) && (curdir[1] == DRIV_SEP_CH) )
        isRoot = TRUE ;
    else
        isRoot = FALSE ;

    attrib = REGULAR_FILES ;                    // all except directories, and volid
    done = _dos_findfirst( searchstr, attrib, &dta );
//  if ( ! done )
//      fprintf( fBat, "chdir %s\n", curdir );

    while ( ! done )
    {
        fprintf( fBat, "  ren %s ", dta.name );
        _strlwr( dta.name );
        fprintf( fBat, "%s\n", dta.name );
        done = _dos_findnext( &dta );
    }

    attrib = _A_SUBDIR+_A_SYSTEM+_A_HIDDEN ;
    done = _dos_findfirst( "*.*", attrib, &dta );

    while ( ! done )
    {
        strncpy(temp,dta.name, 2);
        if ( ((dta.attrib & _A_SUBDIR) == _A_SUBDIR) && (temp[0] != '.') )
        {
            fprintf( fBat, "  ren %s ", dta.name );
            _strlwr( dta.name );
            fprintf( fBat, "%s\n", dta.name );
            if ( ! isRoot )
                strcat( curdir, "\\" );
            strcat( curdir, dta.name );
            fprintf( fBat, " echo %s\nchdir %s\n", curdir, dta.name );
            _chdir( curdir );
            match_files();                      // recursive call
            _chdir( ".." );
            _getcwd( curdir, sizeof(curdir) );
            fprintf( fBat, "chdir ..\n" );
        }
        done = _dos_findnext( &dta );
    }
}


void    main( int argc, char *argv[] )
/*
        The main section of this utility does several interesting things.  One
        of these is the creation of a table of valid drives.  It assumes that a
        system can have 26 drives (one per letter of the alphabet) and proceeds
        to check each drive.
*/
{
    char        origdir[FS_LEN], bufr[FS_LEN] ;
    unsigned    numofdrives ;
    int         i ;

    tt_init( SHAREWARE_VERSION, 0, pgVERS_, pgTITL_, pgCOPR_ );
    logon(0);

    argc -= 1 ;
    LOOP( i, 1, argc, 1 )                       // process switches first
    {
        ST_CPY( bufr, argv[i] );
        if ( bufr[0] == '/' )                   // only /help allowed
            program_usage();
    }
    LOOP( i, 1, argc, 1 )                       // process parameters
    {
        ST_CPY( bufr, argv[i] );
        if ( bufr[0] != '/' )
            ST_CPY( batFile, bufr );
    }

    fBat = fopen( batFile, "w" );
    if ( ! fBat )
    {
        fprintf( stderr, "Can't open output file %s\n", batFile );
        exit( BAD_EXIT );
    }
    fprintf( stderr, "\a\nCreating batch file %s\n\n", batFile );

    _getcwd( origdir, sizeof(origdir) );        // save current directory

    fprintf( fBat, "@echo off\n\n echo %s\n", origdir );

    match_files();

    _dos_setdrive( origdir[0] - 64, &numofdrives );
    _chdir( origdir );                          // back to original

    _fcloseall();
    exit( GOOD_EXIT );
}
